package Engine.Figure;

import java.util.Random;

public class KnightFightEngine {

	private int moves;
	private String next;
	private Figure[][] board;
	
	public int getMoves() {
		return moves;
	}
	public String getNext() {
		return next;
	}
	
	public void initialize()
	{
		Random r1= new Random();
		Random r2 = new Random();
		Knight s1 = new Knight("bela");
		Knight s2 = new Knight("bela");
		Knight s3 = new Knight("bela");
		Knight s4 = new Knight("crna");
		Knight s5 = new Knight("crna");
		Knight s6 = new Knight("crna");
		King k1 = new King("bela");
		King k2 = new King("crna");
		
		board = new Figure[8][8];
		for(int i=0; i<4;i++)
		{
			int x=r1.nextInt(8);
			deployFigure(x,1,s1);
		    x=r1.nextInt(8);
			deployFigure(x,1,s2);
			x=r1.nextInt(8);
			deployFigure(x,1,s3);
			x=r1.nextInt(8);
			deployFigure(x,1,k1);
		}
		for(int i=0; i<4;i++)
		{
			int x=r2.nextInt(8);
			deployFigure(x,8,s4);
		    x=r2.nextInt(8);
			deployFigure(x,8,s5);
			x=r2.nextInt(8);
			deployFigure(x,8,s6);
			x=r2.nextInt(8);
			deployFigure(x,8,k2);
		}
		
	}
	
	public void deployFigure(int x1, int y1, Figure f)
	{
		board[x1][y1]=f;
	}
	
	public void printBoard()
	{
		for(int i=0;i<8;i++)
			for(int j=0;j<8;j++)
				System.out.println(board[i][j].toString());
	}
	
	public void move(String s1, int y1, String s2, int y2)
	{
		int x1,x2;
		if(s1=="A") x1=0;
		else if(s1=="B") x1=1;
		else if(s1=="C") x1=2;
		else if(s1=="D") x1=3;
		else if(s1=="E") x1=4;
		else if(s1=="F") x1=5;
		else if(s1=="G") x1=6;
		else x1=7;
		
		if(s2=="A") x2=0;
		else if(s2=="B") x2=1;
		else if(s2=="C") x2=2;
		else if(s2=="D") x2=3;
		else if(s2=="E") x2=4;
		else if(s2=="F") x2=5;
		else if(s2=="G") x2=6;
		else x2=7;
		
		if((board[x1][y1]!=null)&&(board[x1][y1].getColor()==next))
			if(board[x1][y1].move(x1, y1, x2, y2)==true)
				if(board[x2][y2]!=null)
					{if(board[x1][y1].getColor()!=board[x2][y2].getColor())
						{
						board[x2][y2]=null;
						board[x2][y2]=board[x1][y1];
						board[x1][y1]=null;
						moves++;
						}
					}
				else{
					board[x2][y2]=board[x1][y1];
					board[x1][y1]=null;
					moves++;
				}
	}
	
public boolean isEnd()
{
	for(int i=0;i<8;i++)
		for(int j=0;j<8;j++)
			if(board[i][j].getClass()==King.class)
			{
				return false;
			}
		 return true;
}

public String getWinner()
{
	for(int i=0;i<8;i++)
		for(int j=0;j<8;j++)
			if(board[i][j].getClass()==King.class)
				return board[i][j].getColor();
	return("Greska");
}

public Figure[] getFigures(String color)
{
	int k=0;
	Figure[] niz = new Figure[k];
	niz[k]=null;
	for(int i=0;i<8;i++)
		for(int j=0;j<8;j++)
			if(board[i][j].getColor()==color)
			{
				niz[k]=board[i][j];
			}
	return niz;
}

public int[] getPosition(Figure f)
{	int[] niz = new int[2];
	
	for(int i=0;i<8;i++)
		for(int j=0;j<8;j++)
			if(board[i][j].equals(f))
			{
				niz[0]=i;
				niz[1]=j;
			}
	return niz;
}
	
	
}
